;****************************************
;                                       *
; blink - Blinks an LED on RA0          *
; (c) 2002 by Kai Uwe Schmidt           *
; http://www.kai-uwe-schmidt.de         *
;                                       *
;****************************************

                      list p=16F84A
                      include <p16f84a.inc>


                      __CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON & _HS_OSC


l1                    equ 0x0C
l2                    equ 0x0D
l3                    equ 0x0E


                      org 0x000
                      clrf PCLATH
                      goto main


wait                  movlw 0xFF
                      movwf l1
                      movwf l2
                      movlw 0x01
                      movwf l3
wait_loop             decfsz l1, f
                      goto wait_loop
                      decfsz l2, f
                      goto wait_loop
                      decfsz l3, f
                      goto wait_loop
                      return


main                  bsf STATUS, RP0
                      clrf TRISA              ; set PORT A to output
                      bcf STATUS, RP0
                      ; clrf PORTA              ; Set all bits to 0
                      
                      ; set all bits to 1 (LEDs off)
                      movlw 0xFF
                      movwf PORTA             

                      ; Keep RA1 off
main_loop             movf PORTA, w           
                      xorlw 0x02              ; Mask all but 3rd bit,
                      movwf PORTA             ; i.e., RA1

                      call wait               ; 
                      goto main_loop          ; Repeat
                      end
