	list p=16f84a
	include p16f84a.inc

	__config _CP_OFF & _PWRTE_ON & _WDT_OFF & _HS_OSC

	;; ----------------------------------------

add8	macro src, dst
	movfw src
	addwf dst, F
	endm

adc8	macro src, dst
	movfw src
	skpnc
	addlw 1
	addwf dst, F
	endm

add32	macro src, dst
	add8 src, dst
	adc8 src+1, dst+1
	adc8 src+2, dst+2
	adc8 src+3, dst+3
	endm

swap8	macro fst, snd
	movfw fst
	xorwf snd, W
	xorwf fst, F
	xorwf snd, F
	endm

swap32	macro fst, snd
	swap8 fst, snd
	swap8 fst+1, snd+1
	swap8 fst+2, snd+2
	swap8 fst+3, snd+3
	endm

mov8	macro src, dst
	movfw src
	movwf dst
	endm

mov32	macro src, dst
	mov8 src, dst
	mov8 src+1, dst+1
	mov8 src+2, dst+2
	mov8 src+3, dst+3
	endm

movlf	macro dst, val
	movlw val
	movwf dst
	endm

movlf32	macro dst, b0, b1, b2, b3
	movlf dst, b0
	movlf dst+1, b1
	movlf dst+2, b2
	movlf dst+3, b3
	endm

dec32	macro x
	local fin
	decf x, F
	incfsz x, W
	goto fin
	decf x+1, F
	incfsz x+1, W
	goto fin
	decf x+2, F
	incfsz x+2, W
	goto fin
	decf x+3, F
	incf x+3, W
fin:	
	endm

djnn32	macro x, j
	dec32 x
	addlw 0
	skpz
	goto j
	endm

	;; ----------------------------------------

vA	equ 0x0c
vB	equ 0x10
vC	equ 0x14
vW	equ 0x18
	
	org 0x00
reset:	
	clrf PCLATH
	goto start

	org 0x04
interrupt:	
	retfie

	;; ----------------------------------------

start:
	bsf STATUS, RP0
	movlf TRISA, b'11110'
	bcf STATUS, RP0
	movlf PORTA, 0x00

	movlf32 vA, 1, 0, 0, 0
	movlf32 vB, 1, 0, 0, 0

	movlf32 vW, 0, 0, 0x01, 0
	call wait

again:	
	mov32 vA, vC
	dec32 vC
	call flashn
	mov32 vB, vC
	dec32 vC
	call flashn
	add32 vB, vA
	add32 vA, vB
	goto again

flashn:
	movfw PORTA
	xorlw 0x01
	movwf PORTA

	movlf32 vW, 0, 0x10, 0, 0
	call wait

	movfw PORTA
	xorlw 0x01
	movwf PORTA

	movlf32 vW, 0, 0x30, 0, 0
	call wait
	djnn32 vC, flashn
	
	movlf32 vW, 0, 0xc0, 0, 0
	call wait
	return

wait:
	djnn32 vW, wait
	return

	end
	