	list p=16f84a
	include p16f84a.inc

	__config _CP_OFF & _PWRTE_ON & _WDT_OFF & _HS_OSC

	;; ----------------------------------------

movlf	macro f, l
	movlw l
	movwf f
	endm

	;; ----------------------------------------

savW	equ 0x0c
savS	equ 0x0d
dur	equ 0x0e
count	equ 0x0f
inccnt	equ 0x10
TMR_INIT equ 0xf0

	;; ----------------------------------------

	org 0x00
reset:
	clrf PCLATH
	goto start

	org 0x04
interrupt:
	movwf savW
	movfw STATUS
	movwf savS

	btfss INTCON, T0IF
	goto after_t0if
	movlf TMR0, TMR_INIT
	bcf INTCON, T0IF
	decfsz count, F
	goto after_t0if
	
	movfw dur
	movwf count
	movfw PORTA
	xorlw 0x01
	movwf PORTA

	decfsz inccnt, F
	goto after_t0if
	incf dur, W
	addlw -0x0c
	skpnz
	movlw -0x04
	addlw 0x0c
	movwf dur
after_t0if:
	
	movfw savS
	movwf STATUS
	movfw savW
	retfie

start:
	;; Enable RA0 output
	;; Enable Timer0 with 1:4 prescaler
	bsf STATUS, RP0
	movlf TRISA, b'11110'
	movlf OPTION_REG, b'11000001'
	bcf STATUS, RP0
	
	movlf PORTA, 0x00
	
	movlw 0x0a
	movwf dur
	movwf count

	movlf TMR0, TMR_INIT
	bsf INTCON, T0IE
	bsf INTCON, GIE

again:
	goto again

	end
	